Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/Schedule.cs	(revision 6406)
@@ -0,0 +1,162 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("Schedule", "Represents the general solution for scheduling problems.")]
+  [StorableClass]
+  public class Schedule : NamedItem {
+    #region Properties
+    [Storable]
+    private ItemList<Resource> resources;
+    public ItemList<Resource> Resources {
+      get { return resources; }
+      set {
+        if (resources != null) DeregisterResourcesEvents();
+        resources = value;
+        if (resources != null) RegisterResourcesEvents();
+        OnResourcesChanged();
+      }
+    }
+    [Storable]
+    private DoubleValue quality;
+    public DoubleValue Quality {
+      get { return quality; }
+      set {
+        if (quality != value) {
+          if (quality != null) DeregisterQualityEvents();
+          quality = value;
+          if (quality != null) RegisterQualityEvents();
+          OnQualityChanged();
+        }
+      }
+    }
+    [Storable]
+    private Dictionary<int, ScheduledTask> lastScheduledTaskOfJob;
+    #endregion
+
+    [StorableConstructor]
+    protected Schedule(bool deserializing) : base(deserializing) { }
+    protected Schedule(Schedule original, Cloner cloner)
+      : base(original, cloner) {
+      this.Resources = cloner.Clone(original.Resources);
+      this.Quality = cloner.Clone(original.Quality);
+      this.lastScheduledTaskOfJob = new Dictionary<int, ScheduledTask>(original.lastScheduledTaskOfJob);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Schedule(this, cloner);
+    }
+    public Schedule(int nrOfResources) {
+      Resources = new ItemList<Resource>();
+      for (int i = 0; i < nrOfResources; i++) {
+        Resources.Add(new Resource(i));
+      }
+      lastScheduledTaskOfJob = new Dictionary<int, ScheduledTask>();
+    }
+
+
+    #region Events
+    public event EventHandler QualityChanged;
+    private void OnQualityChanged() {
+      var changed = QualityChanged;
+      if (changed != null)
+        changed(this, EventArgs.Empty);
+    }
+    private void RegisterQualityEvents() {
+      Quality.ValueChanged += new EventHandler(Quality_ValueChanged);
+    }
+    private void DeregisterQualityEvents() {
+      Quality.ValueChanged -= new EventHandler(Quality_ValueChanged);
+    }
+    private void Quality_ValueChanged(object sender, EventArgs e) {
+      OnQualityChanged();
+    }
+
+    public event EventHandler ResourcesChanged;
+    private void OnResourcesChanged() {
+      var changed = ResourcesChanged;
+      if (changed != null)
+        changed(this, EventArgs.Empty);
+    }
+    private void RegisterResourcesEvents() {
+      Resources.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(Resources_PropertyChanged);
+    }
+    private void DeregisterResourcesEvents() {
+      Resources.PropertyChanged -= new System.ComponentModel.PropertyChangedEventHandler(Resources_PropertyChanged);
+    }
+    private void Resources_PropertyChanged(object sender, EventArgs e) {
+      OnResourcesChanged();
+    }
+    #endregion
+
+    public void ScheduleTask(int resNr, double startTime, double duration, int jobNr) {
+      ScheduledTask task = new ScheduledTask(resNr, startTime, duration, jobNr);
+      Resource affectedResource = resources[task.ResourceNr.Value];
+      int i = 0;
+      while (i < affectedResource.Tasks.Count && affectedResource.Tasks[i].StartTime.Value < task.StartTime.Value)
+        i++;
+
+      if (i >= affectedResource.Tasks.Count)
+        affectedResource.Tasks.Add(task);
+      else
+        affectedResource.Tasks.Insert(i, task);
+
+      if (!lastScheduledTaskOfJob.ContainsKey(jobNr))
+        lastScheduledTaskOfJob.Add(jobNr, task);
+      else
+        lastScheduledTaskOfJob[jobNr] = task;
+    }
+
+    public ScheduledTask GetLastScheduledTaskForJobNr(int jobNr) {
+      if (lastScheduledTaskOfJob.ContainsKey(jobNr))
+        return lastScheduledTaskOfJob[jobNr];
+      else
+        return null;
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[ ");
+      foreach (Resource r in Resources) {
+        sb.Append(r.ToString() + " \n");
+      }
+      sb.Append("]");
+      return sb.ToString();
+    }
+
+    public double CalculateMakespan() {
+      double quality = 0;
+      foreach (Resource r in Resources) {
+        if (r.TotalDuration.Value > quality) {
+          quality = r.TotalDuration.Value;
+        }
+      }
+      return quality;
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleEncoding/ScheduledTask.cs	(revision 6406)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("ScheduledTaskClass", "Represents a task that has been scheduled already.")]
+  [StorableClass]
+  public class ScheduledTask : Item {
+    #region Properties
+    [Storable]
+    public IntValue ResourceNr { get; set; }
+    [Storable]
+    public DoubleValue Duration { get; set; }
+    [Storable]
+    public DoubleValue StartTime { get; set; }
+    public DoubleValue EndTime {
+      get {
+        return new DoubleValue(Duration.Value + StartTime.Value);
+      }
+    }
+    [Storable]
+    public IntValue JobNr { get; set; }
+    #endregion
+
+    [StorableConstructor]
+    protected ScheduledTask(bool deserializing) : base(deserializing) { }
+    protected ScheduledTask(ScheduledTask original, Cloner cloner)
+      : base(original, cloner) {
+      this.ResourceNr = cloner.Clone(original.ResourceNr);
+      this.Duration = cloner.Clone(original.Duration);
+      this.StartTime = cloner.Clone(original.StartTime);
+      this.JobNr = cloner.Clone(original.JobNr);
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ScheduledTask(this, cloner);
+    }
+
+    public ScheduledTask(int resNr, double startTime, double duration, int jobNr)
+      : base() {
+      Duration = new DoubleValue(duration);
+      ResourceNr = new IntValue(resNr);
+      StartTime = new DoubleValue(startTime);
+      JobNr = new IntValue(jobNr);
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[" + JobNr + "," + ResourceNr + "]");
+      return sb.ToString();
+    }
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs	(revision 6406)
+++ /branches/Scheduling/HeuristicLab.Encodings.ScheduleEncoding/3.3/ScheduleManipulator.cs	(revision 6406)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ScheduleEncoding {
+  [Item("ScheduleManipulator", "A scheduling manipulation operation.")]
+  [StorableClass]
+  public abstract class ScheduleManipulator<T> : SingleSuccessorOperator, IScheduleManipulator, IStochasticOperator where T : Item {
+    #region IScheduleManipulator Members
+
+    public ILookupParameter<T> ScheduleEncodingParameter {
+      get { return (ILookupParameter<T>)Parameters["ScheduleEncoding"]; }
+    }
+
+    #endregion
+
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+
+    [StorableConstructor]
+    protected ScheduleManipulator(bool deserializing) : base(deserializing) { }
+    protected ScheduleManipulator(ScheduleManipulator<T> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public ScheduleManipulator()
+      : base() {
+      Parameters.Add(new LookupParameter<T>("ScheduleEncoding", "The scheduling solution to be manipulated."));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+    }
+
+  }
+}
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/HeuristicLab.Problems.Scheduling.Views-3.3.csproj	(revision 6406)
@@ -115,11 +115,11 @@
       <Name>HeuristicLab.Encodings.PermutationEncoding-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.SchedulingEncoding.Views\3.3\HeuristicLab.Encodings.SchedulingEncoding.Views-3.3.csproj">
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.ScheduleEncoding.Views\3.3\HeuristicLab.Encodings.ScheduleEncoding.Views-3.3.csproj">
       <Project>{0C378762-D5DB-488A-8931-2BA42B1B7CBF}</Project>
-      <Name>HeuristicLab.Encodings.SchedulingEncoding.Views-3.3</Name>
+      <Name>HeuristicLab.Encodings.ScheduleEncoding.Views-3.3</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.SchedulingEncoding\3.3\HeuristicLab.Encodings.SchedulingEncoding-3.3.csproj">
+    <ProjectReference Include="..\..\HeuristicLab.Encodings.ScheduleEncoding\3.3\HeuristicLab.Encodings.ScheduleEncoding-3.3.csproj">
       <Project>{17F3EF80-B2C3-4B8D-A4D5-BE9CE3BA2606}</Project>
-      <Name>HeuristicLab.Encodings.SchedulingEncoding-3.3</Name>
+      <Name>HeuristicLab.Encodings.ScheduleEncoding-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/JobShopSchedulingProblemView.Designer.cs	(revision 6406)
@@ -1,3 +1,3 @@
-﻿using HeuristicLab.Encodings.SchedulingEncoding.Views;
+﻿using HeuristicLab.Encodings.ScheduleEncoding.Views;
 namespace HeuristicLab.Problems.Scheduling.Views {
   partial class JobShopSchedulingProblemView {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Plugin.cs	(revision 6406)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.Scheduling.Views {
-  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6294")]
+  [Plugin("HeuristicLab.Problems.Scheduling.Views", "3.3.3.6364")]
   [PluginFile("HeuristicLab.Problems.Scheduling.Views-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabProblemsSchedulingViewsPlugin : PluginBase {
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling.Views/3.3/Properties/AssemblyInfo.cs	(revision 6406)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.6294")]
+[assembly: AssemblyFileVersion("3.3.0.6364")]
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/BestSchedulingSolutionAnalyzer.cs	(revision 6406)
@@ -20,17 +20,14 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Optimization;
-using HeuristicLab.Core;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
-using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.SchedulingEncoding;
 
-namespace HeuristicLab.Problems.Scheduling.Analyzers {
+namespace HeuristicLab.Problems.Scheduling {
 
   [Item("BestSchedulingSolutionAnalyzer", "An operator for analyzing the best solution of Scheduling Problems given in schedule-representation.")]
@@ -53,5 +50,6 @@
     }
 
-    public BestSchedulingSolutionAnalyzer () : base () {
+    public BestSchedulingSolutionAnalyzer()
+      : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator."));
     }
@@ -59,5 +57,5 @@
     public override IOperation Apply() {
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
-      ItemArray<Schedule> solutions = SchedulingSolutionParameter.ActualValue;
+      ItemArray<Schedule> solutions = ScheduleParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
       bool max = MaximizationParameter.ActualValue.Value;
@@ -79,5 +77,5 @@
       if (bestSolution == null) {
         bestSolution = (Schedule)solutions[i].Clone();
-        bestSolution.Quality.Value = qualities [i].Value;
+        bestSolution.Quality = (DoubleValue)qualities[i].Clone();
         BestSolutionParameter.ActualValue = bestSolution;
         results.Add(new Result("Best Scheduling Solution", bestSolution));
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/SchedulingAnalyzer.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/SchedulingAnalyzer.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Analyzers/SchedulingAnalyzer.cs	(revision 6406)
@@ -20,19 +20,15 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HeuristicLab.Data;
-using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
-using HeuristicLab.Encodings.SchedulingEncoding;
 
-namespace HeuristicLab.Problems.Scheduling.Analyzers {
-  [Item("Scheduling Analyzer", "Represents the generalized form of Analyzers for Scheduling Problems.")]
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("SchedulingAnalyzer", "Represents the generalized form of Analyzers for Scheduling Problems.")]
   [StorableClass]
   public abstract class SchedulingAnalyzer : SingleSuccessorOperator, IAnalyzer {
@@ -62,13 +58,14 @@
       get { return (LookupParameter<Schedule>)Parameters["BestKnownSolution"]; }
     }
-    public ScopeTreeLookupParameter<Schedule> SchedulingSolutionParameter {
-      get { return (ScopeTreeLookupParameter<Schedule>)Parameters["DecodedSchedulingSolution"]; }
+    public ScopeTreeLookupParameter<Schedule> ScheduleParameter {
+      get { return (ScopeTreeLookupParameter<Schedule>)Parameters["Schedule"]; }
     }
     #endregion
 
-    public SchedulingAnalyzer () : base() {
+    public SchedulingAnalyzer()
+      : base() {
       Parameters.Add(new LookupParameter<BoolValue>("Maximization", "True if the problem is a maximization problem."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the JSSP solutions which should be analyzed."));
-      Parameters.Add(new ScopeTreeLookupParameter<Schedule>("DecodedSchedulingSolution", "The solutions from which the best solution has to be chosen from."));
+      Parameters.Add(new ScopeTreeLookupParameter<Schedule>("Schedule", "The solutions from which the best solution has to be chosen from."));
       Parameters.Add(new LookupParameter<Schedule>("BestSolution", "The best JSSP solution."));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the best JSSP solution should be stored."));
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/GTAlgorithmUtils.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/GTAlgorithmUtils.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/GTAlgorithmUtils.cs	(revision 6406)
@@ -1,10 +1,28 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Encodings.SchedulingEncoding;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
 
-namespace HeuristicLab.Problems.Scheduling.Decoders {
+namespace HeuristicLab.Problems.Scheduling {
   public static class GTAlgorithmUtils {
 
@@ -45,7 +63,7 @@
       return result;
     }
-    
+
     public static double ComputeEarliestStartTime(Task t, Schedule schedule) {
-      ScheduledTask previousTask = schedule.GetLastScheduledTaskForJobNr (t.JobNr.Value);
+      ScheduledTask previousTask = schedule.GetLastScheduledTaskForJobNr(t.JobNr.Value);
       Resource affectedResource = schedule.Resources[t.ResourceNr.Value];
       double lastMachineEndTime = affectedResource.TotalDuration.Value;
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecoder.cs	(revision 6406)
@@ -20,36 +20,19 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Common;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.ScheduleEncoding;
+using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HeuristicLab.Encodings.SchedulingEncoding.JobSequenceMatrix;
-using HeuristicLab.Encodings.SchedulingEncoding;
-using HeuristicLab.Problems.Scheduling.Interfaces;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Scheduling.Decoders {
-  [Item("Job Sequence Matrix Decoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequence Matrix.")]
+namespace HeuristicLab.Problems.Scheduling {
+  [Item("JobSequenceMatrixDecoder", "Applies the GifflerThompson algorithm to create an active schedule from a JobSequence Matrix.")]
   [StorableClass]
-  public class JSMDecoder : SchedulingDecoder<JSMEncoding>, IStochasticOperator, IJSSPOperator {
-    [StorableConstructor]
-    protected JSMDecoder(bool deserializing) : base(deserializing) { }
-    protected JSMDecoder(JSMDecoder original, Cloner cloner)
-      : base(original, cloner) {
-        this.resultingSchedule = cloner.Clone(original.resultingSchedule);
-        this.jobs = cloner.Clone(original.jobs);
-        this.decodingErrorPolicy = original.decodingErrorPolicy;
-        this.forcingStrategy = original.forcingStrategy;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new JSMDecoder(this, cloner);
-    }
-
+  public class JSMDecoder : ScheduleDecoder<JSMEncoding>, IStochasticOperator, IJSSPOperator {
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -70,6 +53,19 @@
 
     [Storable]
-    private JSMForcingStrategyTypes forcingStrategy = JSMForcingStrategyTypes.ShiftForcing; 
+    private JSMForcingStrategyTypes forcingStrategy = JSMForcingStrategyTypes.ShiftForcing;
     #endregion
+
+    [StorableConstructor]
+    protected JSMDecoder(bool deserializing) : base(deserializing) { }
+    protected JSMDecoder(JSMDecoder original, Cloner cloner)
+      : base(original, cloner) {
+      this.resultingSchedule = cloner.Clone(original.resultingSchedule);
+      this.jobs = cloner.Clone(original.jobs);
+      this.decodingErrorPolicy = original.decodingErrorPolicy;
+      this.forcingStrategy = original.forcingStrategy;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new JSMDecoder(this, cloner);
+    }
 
     public JSMDecoder()
@@ -77,11 +73,12 @@
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
       Parameters.Add(new LookupParameter<ItemList<Job>>("JobData", "Job data taken from the Schedulingproblem - Instance."));
+      ScheduleEncodingParameter.ActualName = "JobSequenceMatrix";
     }
 
-    
+
     private Task SelectTaskFromConflictSet(int conflictedResourceNr, int progressOnConflictedResource, ItemList<Task> conflictSet, ItemList<Permutation> jsm) {
       if (conflictSet.Count == 1)
         return conflictSet[0];
-      
+
       //get solutionCandidate from jobSequencingMatrix
       int solutionCandidateJobNr = jsm[conflictedResourceNr][progressOnConflictedResource];
@@ -104,5 +101,5 @@
     }
     private Task ApplyDecodingErrorPolicy(ItemList<Task> conflictSet, Permutation resource, int progress) {
-      if (decodingErrorPolicy == JSMDecodingErrorPolicyTypes.RandomPolicy) { 
+      if (decodingErrorPolicy == JSMDecodingErrorPolicyTypes.RandomPolicy) {
         //Random
         return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
@@ -118,5 +115,5 @@
         }
         return conflictSet[RandomParameter.ActualValue.Next(conflictSet.Count - 1)];
-      }    
+      }
     }
     private void ApplyForcingStrategy(ItemList<Permutation> jsm, int conflictedResource, int newResolutionIndex, int progressOnResource, int newResolution) {
@@ -132,9 +129,9 @@
           asList.Insert(progressOnResource, newResolution);
         } else {
-          asList.Insert(progressOnResource, newResolution); 
+          asList.Insert(progressOnResource, newResolution);
           asList.RemoveAt(newResolutionIndex);
         }
-        jsm[conflictedResource] = new Permutation (PermutationTypes.Absolute, asList.ToArray<int>());
-      } 
+        jsm[conflictedResource] = new Permutation(PermutationTypes.Absolute, asList.ToArray<int>());
+      }
     }
 
@@ -143,5 +140,5 @@
 
       jobs = (ItemList<Job>)jobData.Clone();
-      resultingSchedule = new Schedule(new IntValue(jobs[0].Tasks.Count));
+      resultingSchedule = new Schedule(jobs[0].Tasks.Count);
 
       //Reset scheduled tasks in result
@@ -186,5 +183,5 @@
     public override IOperation Apply() {
       return base.Apply();
-    }    
+    }
   }
 }
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecodingErrorPolicyTypes.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecodingErrorPolicyTypes.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMDecodingErrorPolicyTypes.cs	(revision 6406)
@@ -1,8 +1,23 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-
-namespace HeuristicLab.Problems.Scheduling.Decoders {
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+namespace HeuristicLab.Problems.Scheduling {
   public enum JSMDecodingErrorPolicyTypes {
     RandomPolicy,
Index: /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMForcingStrategyTypes.cs
===================================================================
--- /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMForcingStrategyTypes.cs	(revision 6405)
+++ /branches/Scheduling/HeuristicLab.Problems.Scheduling/3.3/Decoders/JSMForcingStrategyTypes.cs	(revision 6406)
@@ -1,8 +1,24 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
 
-namespace HeuristicLab.Problems.Scheduling.Decoders {
+namespace HeuristicLab.Problems.Scheduling {
   public enum JSMForcingStrategyTypes {
     ShiftForcing,
